
#Comando para limpar a variável list_t_interval para definir o intervalo de tempo 
#para monitorar a conexão

global list_t_interval
set list_t_interval {}
puts "list_t_interval:$list_t_interval"


#*************************************************************************************
#Criação da tela de configuração
#************************************************************************************

#************************************************************************************
#Incluímos o comando trace que associa a chamada do procedimento inst toda vez que a 
#a variável PH, COND ou OD for modificada pois observamos a necessidade de criar
#primeiro os checkbuttons e depois criar a vinculação. Senão no momento da criação
#do checkbutton a rotina "remover eletrodo_$par" seria chamada sem ter um objeto 
#para ser removido
#***********************************************************************************


proc tela_config { janela_seguinte } {
    

    global par_monit fonte_media
    global pH_mV COND OD TEMP
    global config    
    global unidade_ph_mv unidade_cond unidade_od unidade_temp

    global nome_porta_serial nome_porta_usbserial num_porta_serial
    global plataforma

#set par_monit {"pH"  "Eletrodo de pH" {"pH" "pH"} "COND" "Condutividade" {"Conductivity" "uS/cm"} \
#    "OD" "Oxigênio Dissolvido" {"Concentration" "mg/L"} }


destroy .janela  
destroy .cfg



set config [frame .cfg]

set mensagem [label $config.msg -font $fonte_media -wraplength 7i -justify left -text "Programa para aquisição automática \
das leituras do potenciômetro \"Orion 5 STAR\" da \"Thermo\".\ 
Selecione os eletrodos instalados e as respectivas unidades. \n Bom Trabalho!"]



set config_ph_mv [labelframe $config.ph_mv -text "pH/ISE" ]
set config_cond   [labelframe $config.cond -text "Condutividade" ]
set config_od     [labelframe $config.od -text "Oxigênio Dissolvido" ]
set config_temp   [labelframe $config.temp -text "Temperatura"]
set config_tempo  [labelframe $config.tempo -text "Unidade de Tempo"]
set config_porta_serial     [labelframe $config.porta_serial -text "Porta Serial" ]

#Frames filho do labelframe config_porta_serial para configurar porta serial ou usb
#no Linux. No Windows é usado apenas o conf_serial
set conf_serial [frame $config_porta_serial.serial]
set conf_usbserial [frame $config_porta_serial.usbserial]

pack $conf_serial $conf_usbserial -anchor w


checkbutton $config_ph_mv.par_ph -text "pH/ISE" -font $fonte_media -variable pH_mV -command ";#puts\$pH_mV"

pack $config_ph_mv.par_ph

foreach { unidade1 unidade2 } { "pH" {"pH" "pH"} "mV" {"mV" "mV"} "RmV" {"Relative" "RmV"} "ISE:ppb" {"Concentration" "ppb"} } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_ph_mv.$nome_minusculo -text "$unidade1" \
	-font $fonte_media -relief flat -anchor w  \
	-variable unidade_ph_mv -value $unidade2 \
	-command ";#puts\$unidade_ph_mv"
    
    pack $config_ph_mv.$nome_minusculo -side top -anchor w
    
}



checkbutton $config_cond.par_cond -text "Cond" -font $fonte_media -variable COND -command ";#puts\$COND"

pack $config_cond.par_cond

foreach { unidade1 unidade2 } { "uS/cm" {"Conductivity" "uS/cm"} "mg/L" {"TDS" "mg/L"} "ppt" {"Salinity" "ppt"} "Mohmxcm" {"Resistivity" "Mohmxcm"} } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_cond.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable unidade_cond -value $unidade2 -command ";#puts\$unidade_cond"
    
    pack $config_cond.$nome_minusculo -side top -anchor w
    
}



checkbutton $config_od.par_od -text "OD" -font $fonte_media -variable OD -command ";#puts\$OD"

pack $config_od.par_od

foreach { unidade1 unidade2 } { "mg/L" {"Concentration" "mg/L"} "% sat" {"Saturation" "% sat"} } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_od.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable unidade_od -value $unidade2 -command ";#puts\$unidade_od"
    
    pack $config_od.$nome_minusculo -side top -anchor w
    
}

#Checkbutton para ativar o monitoramento da temperatura 
#como existe apenas uma unidade para temperatura eliminei o radiobutton
#que serviria apenas para definir a variável unidade_temp

checkbutton $config_temp.par_temp -text "Celsius" -font $fonte_media -variable TEMP \
 -command {
tk_messageBox -message "Atenção! \nO monitoramento da temperatura é feito utilizando o \
termistor do sensor de OD."
    }

pack $config_temp.par_temp

set unidade_temp {"Temp.Solution" "C"}

#radiobutton $config_temp.c -text "C" -font $fonte_media -relief flat -anchor w  \
#    -variable unidade_temp -value C 
    
#pack $config_temp.c -side top -anchor w
    
#Radiobutton para definir a unidade de tempo (h, m, s)

foreach { unidade1 unidade2 } { "Hora" "h" "Minuto" "m" "Segundo" "s" } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_tempo.$nome_minusculo -text "$unidade1" -font $fonte_media \
	-relief flat -anchor w -variable unidade_tempo -value $unidade2
    
    pack $config_tempo.$nome_minusculo -side top -anchor w
    
}

if {$plataforma == "unix"} {    
    
    radiobutton $conf_serial.nome_porta_serial -font $fonte_media -text "/dev/ttyS" \
	-variable nome_porta_serial -value "/dev/ttyS"
    
    spinbox $conf_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_serial -width 2
    
    pack $conf_serial.nome_porta_serial  $conf_serial.numero_porta_serial -side left
    
    radiobutton $conf_usbserial.nome_porta_usbserial -font $fonte_media -text "/dev/ttyUSB" \
	-variable nome_porta_serial -value "/dev/ttyUSB"
    
    spinbox $conf_usbserial.numero_porta_usbserial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_usbserial -width 2
    
    pack $conf_usbserial.nome_porta_usbserial  $conf_usbserial.numero_porta_usbserial -side left
    
} else {
    
    label $conf_serial.nome_porta_serial -font $fonte_media -text $nome_porta_serial
    
    spinbox $conf_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_serial -width 2
    
    pack $conf_serial.nome_porta_serial  $conf_serial.numero_porta_serial -side left
    
}

#label $config_porta_serial.nome_porta_serial -font $fonte_media -text $nome_porta_serial
#spinbox $config_porta_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
#-textvariable num_porta_serial -width 2

#pack $config_porta_serial.nome_porta_serial  $config_porta_serial.numero_porta_serial -side left


set botao [labelframe $config.bt]

button $botao.voltar -font $fonte_media \
    -text "Voltar" -command tela_inicial

button $botao.consultar_db -font $fonte_media \
	-text "Banco de Dados" -command consultar_cadastro

button $botao.continuar -text "Continuar" -font $fonte_media  -command continuar

button $botao.sair -text "Sair" -font $fonte_media -command "exit"

pack $botao.voltar $botao.consultar_db $botao.continuar $botao.sair -side left -expand yes 

pack $mensagem -side top

pack $botao -side bottom -expand yes -fill x -pady 8

pack $config_ph_mv $config_cond $config_od $config_temp $config_tempo $config_porta_serial -side left -padx 5 -pady 8 -expand yes

pack $config

}

#*************************************************************************************
#Criação do procedimento para montar a lista de parâmetros monitorados
#*************************************************************************************


proc continuar {} {
    
    global pH_mV COND OD TEMP
    
    global unidade_ph_mv unidade_cond unidade_od unidade_temp unidade_tempo
    
    global nome_porta_serial num_porta_serial num_porta_usbserial porta_serial
    
    global config par_monit
    
    
    if { !($pH_mV) && !($COND) && !($OD) || ($unidade_tempo == "") } { 
	tk_messageBox -message "Por favor, selecione pelo menos \"1\" eletrodo e a respectiva unidade de medida!" 
	return
    }
    
    
    
    ;#puts"$pH_mV $COND $OD"
    
    set par_monit {}
    
    if { $pH_mV} {
	
	lappend par_monit pH_mV
	lappend par_monit "Eletrodo de pH/ISE"
	lappend par_monit $unidade_ph_mv
	
    }
    
    if { $COND } {
	
	lappend par_monit COND
	lappend par_monit "Condutividade"
	lappend par_monit $unidade_cond
	
    } 
    
#Inclusão do monitoramento da temperatura apenas se o sensor de OD
#estiver instalado

    if { $OD } {
	
	lappend par_monit OD
	lappend par_monit "Oxigênio Dissolvido"
	lappend par_monit $unidade_od
	
	if { $TEMP } {
		lappend par_monit TEMP
		lappend par_monit "Temperatura"
		lappend par_monit $unidade_temp
	    }
		
    } 
    
    set porta_serial {}
    set nome $nome_porta_serial
    

    if { [string equal $nome "/dev/ttyS"] } {

	    set porta_serial [append nome $num_porta_serial]

	} elseif { [string equal $nome "/dev/ttyUSB"] } {

	    set porta_serial [append nome $num_porta_usbserial]

	} else {

	    set porta_serial [append nome $num_porta_serial ":"]

	}
	
    
    puts "porta_serial = $porta_serial"
    
    tela_monit  $config
    
    vincular_objetos $par_monit
    
    return
    
}

#*************************************************************************************
#Criação do procedimento para vincular o checkbox com a rotina de criação de objetos
#*************************************************************************************


proc vincular_objetos lista {

global pH_mV COND OD TEMP

set pH_mV 0
set COND 0
set OD 0
set TEMP 0

foreach {p n u} $lista { trace add variable $p   write [list inst $p $u] }

return

}


#*************************************************************************************
#Um procedimento para "alertar" o usuário para salvar as leituras antes de voltar
#para a tela de configuração
#Usamos a janela tk_dialog para oferecer 2 opções:
#0- Cancelar e permanecer na tela atual
#1- Continuar e voltar para a tela de configuração 
#*************************************************************************************

proc voltar_config { janela } {

    global pH_mV COND OD TEMP
    global par_monit
    
    set resposta [tk_dialog $janela.reconfigurar "Reconfigurar!"  "Você já salvou as leituras realizadas?"  info 0 Cancelar Continuar]
    switch $resposta {
	0 {}
	1 {
	   foreach {p n u} $par_monit { trace remove variable $p   write [list inst $p $u]}
	    tela_config $janela
	}
    }
    
}



proc ler_porta { canal } {
    
    global t_inicial   par_monit
    global estado_experimento  
    global unidade_tempo
    
    #Comando para calcular o tempo atual em milisegundos   
    set t_final [clock clicks -milliseconds]
    
    if { [eof $canal ] } {
	;#puts stderr "Fechando $canal"
	catch { close $canal }
	return 
    }
    
    
    set l [gets $canal]
    
    foreach {p n u} $par_monit {
	
	global $p leituras_dados_$p 
	
	if { [set $p] } {
	    
	    if {([regexp (^[lindex $u 0]) $l unidade0]) && ([regexp ([lindex $u 1]$) $l unidade1])} { 

		;#puts "primeira regexp = [regexp (^[lindex $u 0]) $l unidade0] e segunda regexp = [regexp ([lindex $u 1]$) $l unidade1]"
				
		regexp {(-)*[0-9]+(\.)*[0-9]+} $l l_$p	    
		
		;#puts "Parâmetro $p = [set $p] leitura [set l_$p] e unidades = $unidade0 e $unidade1" 
		
	 if {$unidade_tempo == "h"} {
	
	#Comando para calcular o tempo (em horas) decorrido desde t0
	set t_final [format "%.4f" [expr ($t_final - $t_inicial)/3600000.0]]
	
    } elseif {$unidade_tempo == "m"} {
	
	#Comando para calcular o tempo (em minutos) decorrido desde t0
	set t_final [format "%.2f" [expr ($t_final - $t_inicial)/60000.0]]
	
    } else {
	set t_final [format "%.1f" [expr ($t_final - $t_inicial)/1000.0]]
    }

			
		#Comando regsub usado para substituir as ocorrências de . por , 
		#É possível usar \\. e \\, ou {\.} e {,} ou {,}
		set t_final_br [regsub {\.} $t_final \, ]
		set l_br_$p [regsub {\.} [set l_$p] {,} ]
	
		
		[set leituras_dados_$p] insert end "$t_final_br ($unidade_tempo)  [set l_br_$p]  ($unidade1)\n"
		[set leituras_dados_$p] see end


#Se houver um experimento em andamento então chamamos o procedimento 
#que inicia o uso do objeto da classe medida

if { $estado_experimento } {

iniciar_medida $p  $unidade_tempo  [set l_$p]

}
		return
		
	    }
    
	}
    }
}

proc abrir_porta { nome_porta } {
    
global id_porta

    set baud 9600
    set paridade n
    set bit_dados 8
    set bit_parada 1
    
    set resultado_1 [ catch { set id_porta [open $nome_porta r+] } ]
    
    set resultado_2 [catch {fconfigure $id_porta -mode "$baud,$paridade,$bit_dados,$bit_parada" }]
    
    if { ($resultado_1 != 0) || ($resultado_2 != 0) } {
	set id_porta "SERIAL_ERRO_OPEN"
	return $id_porta
    } else {
	fconfigure $id_porta -blocking 0
	return $id_porta
    }

#set dir [file dirname [info script]]
#set id_porta [open "|tclsh [file join $dir simu_orion.tcl]" r+]
#set id_porta [open "|[file join $dir simu_wtw.tcl]" r+]
#fconfigure $id_porta -buffering line
#return $id_porta
}
