#Comando para limpar a variável list_t_interval para definir o intervalo de tempo 
#para monitorar a conexão

global list_t_interval
set list_t_interval {}
puts "list_t_interval:$list_t_interval"


#*************************************************************************************
#Criação da tela de configuração
#************************************************************************************

#************************************************************************************
#Incluímos o comando trace que associa a chamada do procedimento inst toda vez que a 
#a variável PH, COND ou OD for modificada pois observamos a necessidade de criar
#primeiro os checkbuttons e depois criar a vinculação. Senão no momento da criação
#do checkbutton a rotina "remover eletrodo_$par" seria chamada sem ter um objeto 
#para ser removido
#***********************************************************************************

#***********************************************************************************
#Mudanças específicas para o módulo wtw_multi340i
#Incluído a variável ORP
#***********************************************************************************




proc tela_config { janela_seguinte } {
    

    global par_monit fonte_media
    global pH ORP COND OD TEMP
    global config    
    global unidade_ph unidade_orp  unidade_cond unidade_od unidade_temp
#Sensor usado para monitorar a temperatura
    global sensor_temp
    global nome_porta_serial nome_porta_usbserial num_porta_serial
    global plataforma
    
destroy .janela  
destroy .cfg


set config [frame .cfg]

set mensagem [label $config.msg -font $fonte_media -wraplength 7i -justify left -text "Programa para aquisição automática \
das leituras do medidor Multi 340i da WTW.\ 
Selecione os eletrodos instalados e as respectivas unidades. \n Bom Trabalho!"]



set config_ph_mv [labelframe $config.ph_mv -text "pH/ORP" ]
set config_cond   [labelframe $config.cond -text "Condutividade" ]
set config_od     [labelframe $config.od -text "Oxigênio Dissolvido" ]
set config_temp   [labelframe $config.temp -text "Temperatura"]
set config_tempo  [labelframe $config.tempo -text "Unidade de Tempo"]

#Labelframe para a configuração da porta serial
set config_porta_serial     [labelframe $config.porta_serial -text "Porta Serial" ]

#Frames filho do labelframe config_porta_serial para configurar porta serial ou usb
#no Linux. No Windows é usado apenas o conf_serial
set conf_serial [frame $config_porta_serial.serial]
set conf_usbserial [frame $config_porta_serial.usbserial]

pack $conf_serial $conf_usbserial -anchor w


checkbutton $config_ph_mv.par_ph -text "pH" -font $fonte_media \
    -variable pH -command "set ORP 0" 

checkbutton $config_ph_mv.par_orp -text "ORP (mV)" -font $fonte_media \
    -variable ORP -command "set pH 0"

pack $config_ph_mv.par_ph  $config_ph_mv.par_orp -anchor w

set unidade_ph "pH"

set unidade_orp "mV"

checkbutton $config_cond.par_cond -text "Cond" -font $fonte_media \
    -variable COND -command "set OD 0"

pack $config_cond.par_cond

foreach { unidade1 unidade2 } { "\u00B5S/cm" "\u00E6S/cm" "Sal" "Sal" } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_cond.$nome_minusculo -text "$unidade1" -font $fonte_media \
	-relief flat -anchor w  -variable unidade_cond -value $unidade2
    
    pack $config_cond.$nome_minusculo -side top -anchor w
    
}


checkbutton $config_od.par_od -text "OD" -font $fonte_media \
    -variable OD -command "set COND 0"

pack $config_od.par_od

foreach { unidade1 unidade2 } { "mg/l" "mg/l" "% saturação" "%" } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_od.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable unidade_od -value $unidade2
    
    pack $config_od.$nome_minusculo -side top -anchor w
    
}

#Checkbutton para ativar o monitoramento da temperatura 

set unidade_temp C

checkbutton $config_temp.par_temp -text "Temperatura" -font $fonte_media -variable TEMP \
    -command {
tk_messageBox -message "Atenção! \nO monitoramento da temperatura é feito com o sensor de \
temperatura dos eletrodos. \nEscolha qual sensor você deseja usar para monitorar a temperatura."
    }

pack $config_temp.par_temp

foreach { unidade1 unidade2 } { "pH" "pH pH" "ORP" "mV mV" \
				    "OD" "mg/l %" "COND" "\u00E6S/cm Sal" } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_temp.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable sensor_temp -value $unidade2
    
    pack $config_temp.$nome_minusculo -side top -anchor w
    
}

#Radiobutton para definir a unidade de tempo (h, m, s)

foreach { unidade1 unidade2 } { "Hora" "h" "Minuto" "m" "Segundo" "s" } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_tempo.$nome_minusculo -text "$unidade1" -font $fonte_media \
	-relief flat -anchor w -variable unidade_tempo -value $unidade2
    
    pack $config_tempo.$nome_minusculo -side top -anchor w
    
}


if {$plataforma == "unix"} {    
    
    radiobutton $conf_serial.nome_porta_serial -font $fonte_media -text "/dev/ttyS" \
	-variable nome_porta_serial -value "/dev/ttyS"
    
    spinbox $conf_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_serial -width 2
    
    pack $conf_serial.nome_porta_serial  $conf_serial.numero_porta_serial -side left
    
    radiobutton $conf_usbserial.nome_porta_usbserial -font $fonte_media -text "/dev/ttyUSB" \
	-variable nome_porta_serial -value "/dev/ttyUSB"
    
    spinbox $conf_usbserial.numero_porta_usbserial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_usbserial -width 2
    
    pack $conf_usbserial.nome_porta_usbserial  $conf_usbserial.numero_porta_usbserial -side left
    
} else {
    
    label $conf_serial.nome_porta_serial -font $fonte_media -text $nome_porta_serial
    
    spinbox $conf_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_serial -width 2
    
    pack $conf_serial.nome_porta_serial  $conf_serial.numero_porta_serial -side left
    
}

set botao [labelframe $config.bt]

button $botao.voltar -font $fonte_media \
    -text "Voltar" -command tela_inicial

button $botao.consultar_db -font $fonte_media \
	-text "Banco de Dados" -command consultar_cadastro

button $botao.continuar -text "Continuar" -font $fonte_media  -command continuar

button $botao.sair -text "Sair" -font $fonte_media -command "exit"

pack $botao.voltar $botao.consultar_db $botao.continuar $botao.sair -side left -expand yes 

pack $mensagem -side top

pack $botao -side bottom -expand yes -fill x -pady 8

pack $config_ph_mv $config_cond $config_od $config_temp $config_tempo $config_porta_serial -side left -pady 8 -padx 10 

pack $config

}


#*************************************************************************************
#Criação do procedimento para montar a lista de parâmetros monitorados
#*************************************************************************************


proc continuar {} {
    
    global pH ORP COND OD TEMP
    
    global unidade_ph unidade_orp unidade_cond unidade_od unidade_temp
    
    global nome_porta_serial num_porta_serial num_porta_usbserial porta_serial
    
    global config par_monit
    
    
    if { !($pH) && !($ORP) && !($COND) && !($OD) } { 
	tk_messageBox -message "Por favor, selecione pelo menos \"1\" eletrodo!" 
	return
    }
    
    
    
    #puts "\$pH \$ORP \$COND \$OD -> $pH $ORP $COND $OD"
    
    set par_monit {}
    
    if { $pH } {
	
	lappend par_monit pH
	lappend par_monit "Eletrodo de pH"
	lappend par_monit $unidade_ph 
	
    }
    
    if { $ORP } {
	
	lappend par_monit ORP
	lappend par_monit "Eletrodo de ORP"
	lappend par_monit $unidade_orp 
	
    }

    if { $COND } {
	
	lappend par_monit COND
	lappend par_monit "Condutividade"
	lappend par_monit $unidade_cond
	
    } 
    
    if { $OD } {
	
	lappend par_monit OD
	lappend par_monit "Oxigênio Dissolvido"
	lappend par_monit $unidade_od
	
    } 

#Inclusão do monitoramento da temperatura apenas se o sensor de OD
#estiver instalado

    if { $pH || $ORP || $COND || $OD } {
	
	if { $TEMP } {
	    lappend par_monit TEMP
	    lappend par_monit "Temperatura"
	    lappend par_monit $unidade_temp
	}
	
    } 
    
    set porta_serial {}
    set nome $nome_porta_serial
    

    if { [string equal $nome "/dev/ttyS"] } {

	    set porta_serial [append nome $num_porta_serial]

	} elseif { [string equal $nome "/dev/ttyUSB"] } {

	    set porta_serial [append nome $num_porta_usbserial]

	} else {

	    set porta_serial [append nome $num_porta_serial ":"]

	}
	
    
    #puts "porta_serial = $porta_serial"
    
    tela_monit  $config
    
    vincular_objetos $par_monit
    
    #puts "par_monit -> $par_monit"

    return
    
}

#*************************************************************************************
#Criação do procedimento para vincular o checkbox com a rotina de criação de objetos
#*************************************************************************************


proc vincular_objetos lista {

global pH ORP COND OD TEMP

set pH 0
set ORP 0
set COND 0
set OD 0
set TEMP 0

foreach {p n u} $lista { trace add variable $p   write [list inst $p $u] }

return

}

#*************************************************************************************
#Um procedimento para "alertar" o usuário para salvar as leituras antes de voltar
#para a tela de configuração
#Usamos a janela tk_dialog para oferecer 2 opções:
#0- Cancelar e permanecer na tela atual
#1- Continuar e voltar para a tela de configuração 
#*************************************************************************************

proc voltar_config { janela } {

    global pH ORP COND OD TEMP
    global par_monit
    
    set resposta [tk_dialog $janela.reconfigurar "Reconfigurar!"  "Você já salvou as leituras realizadas?"  info 0 Cancelar Continuar]
    switch $resposta {
	0 {}
	1 {
	   foreach {p n u} $par_monit { trace remove variable $p   write [list inst $p $u]}
	    tela_config $janela
	}
    }
    
}



proc ler_porta { canal } {
    
    global t_inicial   par_monit
    global estado_experimento    
    global sensor_temp
    global unidade_tempo
    
    #Comando para calcular o tempo atual em milisegundos   
    set t_final [clock clicks -milliseconds]

 if {$unidade_tempo == "h"} {
	
	#Comando para calcular o tempo (em horas) decorrido desde t0
	set t_final [format "%.4f" [expr ($t_final - $t_inicial)/3600000.0]]
	
    } elseif {$unidade_tempo == "m"} {
	
	#Comando para calcular o tempo (em minutos) decorrido desde t0
	set t_final [format "%.2f" [expr ($t_final - $t_inicial)/60000.0]]
	
    } else {
	set t_final [format "%.1f" [expr ($t_final - $t_inicial)/1000.0]]
    }

    #Comando regsub usado para substituir as ocorrências de . por , 
    #É possível usar \\. e \\, ou {\.} e {,} ou {,}
    set t_final_br [regsub -all {\.} $t_final \, ]		    

    if { [eof $canal ] } {
	;#puts stderr "Fechando $canal"
	catch { close $canal }
	return 
    }
    
    
    set l [gets $canal]
    
    foreach {p n u} $par_monit {
	
	global $p leituras_dados_$p 
	
	if { [set $p] } {
	    
	    if {$p != "TEMP"} {
		
		if {([regexp ($u) $l])} { 
		    
		    #8/11/12 Adicionei " *" ao padrão para extrair números com espaços entre o sinal (-)
		    #e o número (Ex: U mV)
		    #		regexp {(-)* *[0-9]+(\.)?[0-9]+} $l l_$p	    
		    
		    #Observamos que leituras de ORP sem ponto decimal não estavam sendo lidas. 
		    #Foi resolvido mudando "[0-9]+" por
		    #"[0-9]*" permitindo a leitura de valores sem ponto decimal
		    
		       
		    regexp {(-)* *[0-9]+(\.)?[0-9]*} $l leitura
		   		    
		    #puts "Parâmetro -> $p Leitura -> $l ($leitura) Unidade -> $u"
		    #	puts "sensor_temp [lindex $sensor_temp 0] ou [lindex $sensor_temp 1]"
		    
		    #Para remover os eventuais espaços nas leituras principalmente
		    #as leituras de ORP negativo onde existem espaços entre 
		    #o sinal "-" e o número		    

		    #Outra opção seria set leitura [join $leitura ""]	 
   
		    set leitura [regsub -all " " $leitura ""]
		    
		    
		    #Comando regsub usado para substituir as ocorrências de . por , 
		    #É possível usar \\. e \\, ou {\.} e {,} ou {,}
		    set leitura_br [regsub -all {\.} $leitura {,} ]
		    
		    if {$u == "\u00E6S/cm"} {set u "\u00B5S/cm"}
		    
		    [set leituras_dados_$p] insert end "$t_final_br ($unidade_tempo)  $leitura_br  ($u)\n"
		    
		    [set leituras_dados_$p] see end
		    
		    #Se houver um experimento em andamento então chamamos o procedimento 
		    #que inicia o uso do objeto da classe medida
		    
		    if { $estado_experimento } {
			
			iniciar_medida $p  $unidade_tempo  $leitura
			
		    }

		}
		
#Este teste foi incluído considerando que não existe uma saída dedicada
#para temperatura, mas que é um parâmetro obtido das leituras dos sensores
#O teste inicial verifica se a temperatura está sendo monitorada e 
#em seguida verifica se as unidades do sensor que está sendo usado para
#monitorar a temperatura estão presentes

	    } elseif {[lindex $par_monit end] == "C"} {
		
		set u1 [regexp ([lindex $sensor_temp 0]) $l]
		set u2 [regexp ([lindex $sensor_temp 1]) $l]
		
		if {$u1 || $u2} {

		    regexp -all {[0-9]+(\.)?[0-9]*} $l temperatura


		    #Comando regsub usado para substituir as ocorrências de . por , 
		    #É possível usar \\. e \\, ou {\.} e {,} ou {,}
		    set temperatura_br [regsub -all {\.} $temperatura {,} ]

		    set p TEMP

		    [set leituras_dados_$p] insert end \
			"$t_final_br ($unidade_tempo)  $temperatura_br  (C)\n"
		    [set leituras_dados_$p] see end

		    if { $estado_experimento } {
			
			iniciar_medida $p  $unidade_tempo  $temperatura
			
		    }

		    return
		}
		
	    }
   
	}
    }
}

proc abrir_porta { nome_porta } {
    
global id_porta

    set baud 4800
    set paridade n
    set bit_dados 8
    set bit_parada 2
    
#    set resultado_1 [ catch { set id_porta [open $nome_porta r+] } ]
    
#    set resultado_2 [catch {fconfigure $id_porta -mode "$baud,$paridade,$bit_dados,$bit_parada" }]
    
#    if { ($resultado_1 != 0) || ($resultado_2 != 0) } {
#	set id_porta "SERIAL_ERRO_OPEN"
#	return $id_porta
#    } else {
#A opção -blocking 0 fez uma grande diferença na atualização das telas
#	fconfigure $id_porta -blocking 0
#	return $id_porta
#    }

set dir [file dirname [info script]]
##set id_porta [open "|tclsh [file join $dir simu_orion.tcl]" r+]
#set id_porta [open "|[file join $dir simu_wtw.tcl]" r+]

set id_porta [open "|[file join $dir simu_wtw340i_OD.tcl]" r+]

fconfigure $id_porta -buffering line
return $id_porta
}
