#Módulo para aquisição das leituras de Oxigênio Dissolvido (e Temperatura)
#do medidor Oxi7310 da WTW

#*************************************************************************************
#Criação da tela de configuração
#************************************************************************************

#************************************************************************************
#Incluímos o comando trace que associa a chamada do procedimento inst toda vez que a 
#a variável PH, COND ou OD for modificada pois observamos a necessidade de criar
#primeiro os checkbuttons e depois criar a vinculação. Senão no momento da criação
#do checkbutton a rotina "remover eletrodo_$par" seria chamada sem ter um objeto 
#para ser removido
#***********************************************************************************

#puts [info_time]

#Comando para limpar a variável list_t_interval para definir o intervalo de tempo 
#para monitorar a conexão

global list_t_interval
set list_t_interval {}
puts "list_t_interval:$list_t_interval"

global flag_read

proc tela_config { janela_seguinte } {
    

    global par_monit fonte_media
    global OD TEMP
    global config    
    global unidade_od unidade_temp

#Sensor usado para monitorar a temperatura
    global sensor_temp
    global nome_porta_serial nome_porta_usbserial num_porta_serial
    global plataforma
    
destroy .janela  
destroy .cfg


set config [frame .cfg]

set mensagem [label $config.msg -font $fonte_media -wraplength 10i -justify left \
		  -text "Programa para aquisição automática das leituras de OD e Temperatura do medidor Oxi7310 da WTW.\n Selecione a unidade de medida. \n Bom Trabalho!\n"]

set config_od     [labelframe $config.od -text "Oxigênio Dissolvido" ]
set config_temp   [labelframe $config.temp -text "Temperatura"]
set config_tempo  [labelframe $config.tempo -text "Unidade de Tempo"]

#Labelframe para a configuração da porta serial
set config_porta_serial     [labelframe $config.porta_serial -text "Porta Serial" ]

#Frames filho do labelframe config_porta_serial para configurar porta serial ou usb
#no Linux. No Windows é usado apenas o conf_serial
set conf_serial [frame $config_porta_serial.serial]
set conf_usbserial [frame $config_porta_serial.usbserial]

pack $conf_serial $conf_usbserial -anchor w


checkbutton $config_od.par_od -text "OD" -font $fonte_media \
    -variable OD 

pack $config_od.par_od

foreach { unidade1 unidade2 } { "Concentração (mg/l)" "mg/l" "% saturação" "%" "Pressão Parcial (mbar)" "mbar"} {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_od.$nome_minusculo -text "$unidade1" -font $fonte_media \
	-relief flat -anchor w  \
	-variable unidade_od -value $unidade2
    
    pack $config_od.$nome_minusculo -side top -anchor w
    
}

#Checkbutton para ativar o monitoramento da temperatura 

set unidade_temp C

checkbutton $config_temp.par_temp -text "Temperatura" -font $fonte_media -variable TEMP \
    -command {
	tk_messageBox -message "Atenção! \nO monitoramento da temperatura é feito \
com o sensor de temperatura do eletrodo de OD."
    }

pack $config_temp.par_temp

#Radiobutton para definir a unidade de tempo (h, m, s)

foreach { unidade1 unidade2 } { "Hora" "h" "Minuto" "m" "Segundo" "s" } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_tempo.$nome_minusculo -text "$unidade1" -font $fonte_media \
	-relief flat -anchor w -variable unidade_tempo -value $unidade2
    
    pack $config_tempo.$nome_minusculo -side top -anchor w
    
}

if {$plataforma == "unix"} {    
    
    radiobutton $conf_serial.nome_porta_serial -font $fonte_media -text "/dev/ttyS" \
	-variable nome_porta_serial -value "/dev/ttyS"
    
    spinbox $conf_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_serial -width 2
    
    pack $conf_serial.nome_porta_serial  $conf_serial.numero_porta_serial -side left
    
    radiobutton $conf_usbserial.nome_porta_usbserial -font $fonte_media -text "/dev/ttyUSB" \
	-variable nome_porta_serial -value "/dev/ttyUSB"
    
    spinbox $conf_usbserial.numero_porta_usbserial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_usbserial -width 2
    
    pack $conf_usbserial.nome_porta_usbserial  $conf_usbserial.numero_porta_usbserial -side left
    
} else {
    
    label $conf_serial.nome_porta_serial -font $fonte_media -text $nome_porta_serial
    
    spinbox $conf_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
	-textvariable num_porta_serial -width 2
    
    pack $conf_serial.nome_porta_serial  $conf_serial.numero_porta_serial -side left
    
}

set botao [labelframe $config.bt]

button $botao.voltar -font $fonte_media \
    -text "Voltar" -command tela_inicial

button $botao.consultar_db -font $fonte_media \
	-text "Banco de Dados" -command consultar_cadastro

button $botao.continuar -text "Continuar" -font $fonte_media  -command continuar

button $botao.sair -text "Sair" -font $fonte_media -command "exit"

pack $botao.voltar $botao.consultar_db $botao.continuar $botao.sair -side left -expand yes 

pack $mensagem -side top

pack $botao -side bottom -expand yes -fill x -pady 8

pack $config_od $config_temp $config_tempo $config_porta_serial -expand yes -fill x \
    -side left -pady 8 -padx 10 

pack $config

}


#*************************************************************************************
#Criação do procedimento para montar a lista de parâmetros monitorados
#*************************************************************************************


proc continuar {} {
    
    global OD TEMP
    
    global unidade_od unidade_temp unidade_tempo
    
    global nome_porta_serial num_porta_serial num_porta_usbserial porta_serial
    
    global config par_monit
    
    
    if { !($OD) || ($unidade_od == "") || ($unidade_tempo == "") } { 
	tk_messageBox -message "Por favor, selecione o eletrodo e as unidades de medida!" 
	return
    }
    
    puts "$OD -> $OD"
    
    set par_monit {}
  
    if { $OD } {
	
	lappend par_monit OD
	lappend par_monit "Oxigênio Dissolvido"
	lappend par_monit $unidade_od
	
    } 

#Inclusão do monitoramento da temperatura 

	if { $TEMP } {
	    lappend par_monit TEMP
	    lappend par_monit "Temperatura"
	    lappend par_monit $unidade_temp
	}
	
    
    set porta_serial {}
    set nome $nome_porta_serial
    

#    if { [string equal $nome "/dev/ttyS"] } {

#	    set porta_serial [append nome $num_porta_serial]

#	} elseif { [string equal $nome "/dev/ttyUSB"] } {

#	    set porta_serial [append nome $num_porta_usbserial]

#	} else {

#	    set porta_serial [append nome $num_porta_serial ":"]

#	}

set porta_serial /dev/wtw_oxi7310	
    
    puts "porta_serial = $porta_serial"
    
    tela_monit  $config
    
    vincular_objetos $par_monit
    
    puts "par_monit -> $par_monit"

    return
    
}

#*************************************************************************************
#Criação do procedimento para vincular o checkbox com a rotina de criação de objetos
#*************************************************************************************


proc vincular_objetos lista {

global OD TEMP

set OD 0
set TEMP 0

foreach {p n u} $lista { trace add variable $p   write [list inst $p $u] }

return

}

#*************************************************************************************
#Um procedimento para "alertar" o usuário para salvar as leituras antes de voltar
#para a tela de configuração
#Usamos a janela tk_dialog para oferecer 2 opções:
#0- Cancelar e permanecer na tela atual
#1- Continuar e voltar para a tela de configuração 
#*************************************************************************************

proc voltar_config { janela } {

    global OD TEMP
    global par_monit
    
    set resposta [tk_dialog $janela.reconfigurar "Reconfigurar!"  "Você já salvou as leituras realizadas?"  info 0 Cancelar Continuar]
    switch $resposta {
	0 {}
	1 {
	   foreach {p n u} $par_monit { trace remove variable $p   write [list inst $p $u]}
	    tela_config $janela
	}
    }
    
}


#No modo CSV os dados são enviados de uma única vez como uma string
#com 11 campos delimitados pelo caracter ";"
#inoLab Oxi 7310;12270206;1;01.01.2011;00:08:39;;2,67;;21,9;;AR;
#Campo 6 -> Leituras de OD quando o medidor está lendo em % de saturação
#Campo 7 -> Leituras de OD quando o medidor está lendo em mg/L
#Campo 8 -> Leituras de OD quando o medidor está lendo em mbar

#As leituras de OD são enviadas com "," mas devem ser arquivadas no banco
#de dados com ".", por isso fazemos a substituição com regsub antes
#do comando iniciar_medida

proc ler_porta { canal } {
    
    global t_inicial   par_monit
    global estado_experimento    
    global sensor_temp
    global unidade_tempo
    
    #Comando para calcular o tempo atual em milisegundos   
    set t_final [clock clicks -milliseconds]
    
#Para ser usado pelo calc_interval
    set t_final_ms $t_final

    if {$unidade_tempo == "h"} {
	
	#Comando para calcular o tempo (em horas) decorrido desde t0
	set t_final [format "%.4f" [expr ($t_final - $t_inicial)/3600000.0]]
	
    } elseif {$unidade_tempo == "m"} {
	
	#Comando para calcular o tempo (em minutos) decorrido desde t0
	set t_final [format "%.2f" [expr ($t_final - $t_inicial)/60000.0]]
	
    } else {
	set t_final [format "%.1f" [expr ($t_final - $t_inicial)/1000.0]]
    }

    #Comando regsub usado para substituir as ocorrências de . por , 
    #É possível usar \\. e \\, ou {\.} e {,} ou {,}
    set t_final_br [regsub -all {\.} $t_final \, ]		    
    
    if { [eof $canal ] } {
	;#puts stderr "Fechando $canal"
	catch { close $canal }
	return 
    }
    
    set l [gets $canal]
    
    if {$l != ""} { 

#This command set the global variable flag_read as 1 to
#indicate a new reading
    
    setFlagRead 1

#    puts "ler_porta - entrada de dados flag_read:[getFlagRead]"

#Chamada do procedimento set_int para calcular o intervalo entre leituras
#e monitorar a conexão
    calc_interval $t_final_ms
    } 
    
    set lista_l [split $l ";"]
    
    #puts $lista_l 
    #puts "Campo 6: [lindex $lista_l 5]"
    #puts "Campo 7: [lindex $lista_l 6]"
    #puts "Campo 8: [lindex $lista_l 7]"
    
    foreach {p n u} $par_monit {
	
	global $p leituras_dados_$p 
	
	if {($p == "OD") && ([set $p]) } { 
	    
	    if { $u == "%" } {
		#Se a unidade for % então extrai o sexto campo 
		set l_$p [lindex $lista_l 5]
		
		#E verifica se o equipamento está eviando dados neste campo		
		if {[set l_$p] != ""} {
		    
		    [set leituras_dados_$p] insert end \
			"$t_final_br $unidade_tempo [set l_$p] $u\n"
		    [set leituras_dados_$p] see end

		    if { $estado_experimento } {
			set l_$p [regsub {\,} [set l_$p] \. ]
			iniciar_medida $p  $unidade_tempo  [set l_$p]		    
		    }

		}
		
	    } elseif { $u == "mg/l" } {
		
		#Se a unidade for mg/L extrai o sétimo campo
		set l_$p [lindex $lista_l 6]
		
		#E verifica se o equipamento está eviando dados neste campo
		if {[set l_$p] != ""} {	
		    
		    [set leituras_dados_$p] insert end \
			"$t_final_br $unidade_tempo [set l_$p] $u\n"
		    [set leituras_dados_$p] see end

#puts "$t_final_br $unidade_tempo [set l_$p] $u"

		    if { $estado_experimento } {
			set l_$p [regsub {\,} [set l_$p] \. ]
			iniciar_medida $p  $unidade_tempo  [set l_$p]		    
		    }
		}
		
	    } elseif { $u == "mbar" } {
		
		#Se a unidade for mg/L extrai o sétimo campo
		set l_$p [lindex $lista_l 7]
		
		#E verifica se o equipamento está eviando dados neste campo
		if {[set l_$p] != ""} {			
		    
		    [set leituras_dados_$p] insert end \
			"$t_final_br $unidade_tempo [set l_$p] $u\n"
		    [set leituras_dados_$p] see end

		    if { $estado_experimento } {
			set l_$p [regsub {\,} [set l_$p] \. ]
			iniciar_medida $p  $unidade_tempo  [set l_$p]
		    }

		}
		
	    }

	    
	}
	    
	if {($p == "TEMP") && ([set $p])} { 

	    set l_$p [lindex $lista_l 8]
	    
	    if {[set l_$p] != ""} {
		
		[set leituras_dados_$p] insert end \
		    "$t_final_br $unidade_tempo [set l_$p] $u\n"
		[set leituras_dados_$p] see end
		
		
		if { $estado_experimento } {
		    
		    #Originalmente esse procedimento era chamado com a unidade de tempo em "min"
		    #e substituímos por $unidade_tempo
		    set l_$p [regsub {\,} [set l_$p] \. ]
		    iniciar_medida $p  $unidade_tempo  [set l_$p]
		    
		}
		
	    }

	}
	
    }

}
    


proc abrir_porta { nome_porta } {
    
global id_porta

    set baud 9600
    set paridade n
    set bit_dados 8
    set bit_parada 2
    
puts "abrir_porta - nome_porta:$nome_porta"

    set resultado_1 [ catch { set id_porta [open $nome_porta r+] } ]
    
    set resultado_2 [catch {fconfigure $id_porta -mode "$baud,$paridade,$bit_dados,$bit_parada" }]
    
    if { ($resultado_1 != 0) || ($resultado_2 != 0) } {
	set id_porta "SERIAL_ERRO_OPEN"
	return $id_porta
    } else {
#A opção -blocking 0 fez uma grande diferença na atualização das telas
	fconfigure $id_porta -blocking 0
	return $id_porta
    }

#set dir [file dirname [info script]]
##set id_porta [open "|tclsh [file join $dir simu_orion.tcl]" r+]
#set id_porta [open "|[file join $dir simu_wtw_Oxi7310.tcl]" r+]
#fconfigure $id_porta -buffering line
#return $id_porta
}

########################################################################################
#Abril 2014
#Procedimentos adicionais para monitorar a eventual queda de conexão devido às mudanças
#do número da porta ttyUSB com o medidor WTW_Oxi7310

proc monitConnection {} {
    
    global list_t_interval id_porta porta_serial id_after_monitconnection
    
#    puts "monitConnection flag_read:[getFlagRead] porta:[chan names $id_porta]"
    
    
    if {![getFlagRead]} {

	puts "[info_time] monitConnection - Atraso na leitura, fechando $id_porta"

	catch {close $id_porta}

	set id_porta [abrir_porta $porta_serial]

	if { $id_porta == "SERIAL_ERRO_OPEN" } {

	    setFlagRead 0

	    set delay_monitconnection [expr 4 * [get_interval]]

	    set id_after_monit_connection [after $delay_monitconnection monitConnection]

	    puts "[info_time] monitConnection try reopen port but SERIAL_ERRO_OPEN, will be scheduled after $delay_monitconnection"

	    return
	    
	}

	puts "[info_time] monitConnection - Atraso na leitura, novo id_porta:$id_porta"

	setFlagRead 0

	fileevent $id_porta readable [list ler_porta $id_porta]

	set delay_monitconnection [expr 4 * [get_interval]]

#	set delay_monitconnection [expr int($delay_monitconnection)]
	
	puts "monitConnection after reopen port will be scheduled after $delay_monitconnection"
	
	set id_after_monitconnection [after $delay_monitconnection monitConnection]

	return
    }

    
    	setFlagRead 0
	
#	puts "monitConnection - flag_read:[getFlagRead]"
	
	set delay_monitconnection [expr 4 * [get_interval]]

#	puts "monitConnection will be scheduled after $delay_monitconnection"
	
	set id_after_monitconnection [after $delay_monitconnection monitConnection]
	
}

#Procedimento para calcular o intervalo de tempo entre leituras 
#e permitir o monitoramento da conexão

proc calc_interval { t } {

global interval list_t_interval

#puts "calc_int list_t_interval:$list_t_interval"

    if { [llength $list_t_interval] > 2 } {
	return
    } elseif { [llength $list_t_interval] < 2 } {
	lappend list_t_interval $t
	puts "llength list_t_interval:[llength $list_t_interval]"
    } else {
	set interval [expr [lindex $list_t_interval 1] - [lindex $list_t_interval 0]]
	puts "interval:[get_interval]"
	lappend list_t_interval 0
	monitConnection
    }	

}

proc get_interval {} {
global interval
return $interval
}

proc setFlagRead { f } {

    global flag_read
    
    set flag_read $f
    
#    puts "setFlagRead - flag_read:$flag_read"

    
}

proc getFlagRead {} {

    global flag_read

    return $flag_read
}
